﻿using Syncfusion.UI.Xaml.Grid;
using Syncfusion.Windows.Controls.Input;
using Syncfusion.Windows.Tools.Controls;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Data;

namespace SfDataGridDemo
{
    public class SfDataGridExt : SfDataGrid
    {
        protected ToolBarAdv toolBarRow;
        protected SfTextBoxExt textSearch;

        public SfDataGridExt()
            : base()
        {
            DefaultStyleKeyProperty.OverrideMetadata(typeof(SfDataGridExt), new FrameworkPropertyMetadata(typeof(SfDataGridExt)));
            
            //Exception will raise hence OnApplyTemplate wont called while accessing the toolBarRow here.
            //var s = this.ShowTools;
        }

        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();
            toolBarRow = GetTemplateChild("ToolBarRow") as ToolBarAdv;
            textSearch = GetTemplateChild("TxtSearch") as SfTextBoxExt;

            //vb code
            //toolBarRow = TryCast(GetTemplateChild("ToolBarRow"), ToolBarAdv)
            //textSearch = TryCast(GetTemplateChild("TxtSearch"), ToolBarAdv)
        }

        public bool ShowTools
        {
            get
            {
                //avoid null reference exception by adding null checks here.
                if (toolBarRow.Visibility == System.Windows.Visibility.Visible)
                    return true;
                else
                    return false;
            }
            set
            {
                if (value)
                    toolBarRow.Visibility = System.Windows.Visibility.Visible;
                else
                    toolBarRow.Visibility = System.Windows.Visibility.Collapsed;
            }
        }
    }
}
